/*
 * Device Motion Gesture for JavaScript.
 * http://sourceforge.net/projects/jsmotiongesture/
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 * 
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU General Public License along
 * with the files in this library. If not, see  http://www.gnu.org/licenses
 * Distributed under the GNU Library or Lesser General Public License (LGPL)
 */

if(typeof Motion==="undefined"){Motion={}
}if(typeof Motion.Gesture==="undefined"){Motion.Gesture={}
}Motion.Gesture.Recognition={};
Motion.Gesture.Recognition.ConditionComparator=function(){};
Motion.Gesture.Recognition.ConditionComparator.prototype.isRootControlConiditionMet=function(b,c){for(var a=0;
a<b.length;
a++){if(this.isControlConiditionMet(b[a],c)===false){return false
}}return true
};
Motion.Gesture.Recognition.ConditionComparator.prototype.isControlConiditionMet=function(c,b){for(var a=0;
a<c.points.length;
a++){if(this.isControlPointConiditionMet(c.points[a],b)===false){return false
}}return true
};
Motion.Gesture.Recognition.ConditionComparator.prototype.isControlPointConiditionMet=function(a,c){var b=c[a.axis];
if(b){return(b>a.window.value.min&&b<a.window.value.max)
}else{return false
}};
Motion.Gesture.Recognition.ControlThread=function(b,a){this.control=b;
this.conditionComparator=a;
this.status={};
this.status.expired=false;
this.status.conditionMet=false
};
Motion.Gesture.Recognition.ControlThread.prototype.start=function(b){var a=(b)?b:new Date().getTime();
this.timeFrame={};
this.timeFrame.start=a+this.control.window.time.delay;
this.timeFrame.end=this.timeFrame.start+this.control.window.time.width
};
Motion.Gesture.Recognition.ControlThread.prototype.process=function(a){if(a.timestamp<this.timeFrame.start){return false
}if(a.timestamp>this.timeFrame.end){this.stop();
return true
}if(this.conditionComparator.isControlConiditionMet(this.control,a)===true){this.status.conditionMet=true;
this.stop();
return true
}return false
};
Motion.Gesture.Recognition.ControlThread.prototype.stop=function(){this.status.expired=true
};
Motion.Gesture.Recognition.GestureThread=function(a,b){this.gesture=a;
this.conditionComparator=b;
this.controlThreads=[];
this.status={};
this.status.expired=false;
this.status.conditionMet=false
};
Motion.Gesture.Recognition.GestureThread.prototype.start=function(c){var b=(c)?c:null;
for(var a=0;
a<this.gesture.signature.roots.length;
a++){this.startMonitoringControl(this.gesture.signature.roots[a].next,b)
}};
Motion.Gesture.Recognition.GestureThread.prototype.startMonitoringControl=function(d,c){var b=(c)?c:null;
var a=new Motion.Gesture.Recognition.ControlThread(d,this.conditionComparator);
a.start(b);
this.controlThreads[this.controlThreads.length]=a
};
Motion.Gesture.Recognition.GestureThread.prototype.process=function(c){var e=false;
for(var b=0;
b<this.controlThreads.length;
b++){var d=this.controlThreads[b];
if(d.status.expired===false){var a=d.process(c);
if(a===true){e=true;
if(d.status.expired===true&&d.status.conditionMet&&d.control.next){this.startMonitoringControl(d.control.next,c.timestamp)
}}}}if(e===true){return this.updateStatus()
}else{return false
}};
Motion.Gesture.Recognition.GestureThread.prototype.updateStatus=function(){var a=false;
if(this.allThreadsExpired()===true){if(this.allControlsMet()===true){this.status.conditionMet=true
}this.stop();
a=true
}return a
};
Motion.Gesture.Recognition.GestureThread.prototype.allThreadsExpired=function(){for(var a=0;
a<this.controlThreads.length;
a++){if(this.controlThreads[a].status.expired===false){return false
}}return true
};
Motion.Gesture.Recognition.GestureThread.prototype.allControlsMet=function(){for(var a=0;
a<this.controlThreads.length;
a++){if(this.controlThreads[a].status.conditionMet===false){return false
}}return true
};
Motion.Gesture.Recognition.GestureThread.prototype.stop=function(){this.status.expired=true
};
Motion.Gesture.Recognition.Monitor=function(a){this.conditionComparator=(a)?a:new Motion.Gesture.Recognition.ConditionComparator();
this.gestures=[];
this.gestureTriggers={};
this.gestureThreads=[]
};
Motion.Gesture.Recognition.Monitor.prototype.addGesture=function(b,a){this.removeGesture(b);
this.gestures[this.gestures.length]=b;
this.gestureTriggers[b.id]=a
};
Motion.Gesture.Recognition.Monitor.prototype.removeGesture=function(a){this.stopThreadsForGesture(a);
this.gestureTriggers[a.id]=null;
var b=this.gestures.indexOf(a);
if(b>-1){this.gestures.splice(b,1)
}};
Motion.Gesture.Recognition.Monitor.prototype.stopAllThreads=function(){for(var a=0;
a<this.gestures.length;
a++){this.stopThreadsForGesture(this.gestures[a])
}};
Motion.Gesture.Recognition.Monitor.prototype.stopThreadsForGesture=function(c){for(var b=0;
b<this.gestureThreads.length;
b++){var a=this.gestureThreads[b];
if(a.gesture.id==c.id){a.stop()
}}this.dereferenceExpiredThreads()
};
Motion.Gesture.Recognition.Monitor.prototype.dereferenceExpiredThreads=function(){var a=0;
while(a<this.gestureThreads.length){if(this.gestureThreads[a].status.expired===true){if(this.gestureThreads[a].status.conditionMet===true){var b=this.gestureThreads[a].gesture.id;
this.gestureTriggers[b]()
}this.gestureThreads.splice(a,1)
}else{a++
}}};
Motion.Gesture.Recognition.Monitor.prototype.process=function(a){this.processCurrentThreads(a);
this.processNewThreads(a)
};
Motion.Gesture.Recognition.Monitor.prototype.processCurrentThreads=function(c){var d=false;
for(var b=0;
b<this.gestureThreads.length;
b++){var a=this.gestureThreads[b].process(c);
if(a===true){d=true
}}if(d===true){this.dereferenceExpiredThreads()
}};
Motion.Gesture.Recognition.Monitor.prototype.processNewThreads=function(c){for(var b=0;
b<this.gestures.length;
b++){var a=this.gestures[b];
if(this.conditionComparator.isRootControlConiditionMet(a.signature,c)===true){this.startMonitoringGesture(c.timestamp,a)
}}};
Motion.Gesture.Recognition.Monitor.prototype.startMonitoringGesture=function(c,b){var a=new Motion.Gesture.Recognition.GestureThread(b,this.conditionComparator);
a.start(c);
this.gestureThreads[this.gestureThreads.length]=a
};