/*
 * Device Motion Gesture for JavaScript.
 * http://sourceforge.net/projects/jsmotiongesture/
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 * 
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU General Public License along
 * with the files in this library. If not, see  http://www.gnu.org/licenses
 * Distributed under the GNU Library or Lesser General Public License (LGPL)
 */

if(typeof Motion==="undefined"){Motion={}
}if(typeof Motion.Gesture==="undefined"){Motion.Gesture={}
}Motion.Gesture.Record={};
if(typeof Motion==="undefined"){Motion={}
}if(typeof Motion.Gesture==="undefined"){Motion.Gesture={}
}if(typeof Motion.Gesture.Record==="undefined"){Motion.Gesture.Record={}
}Motion.Gesture.Record.Controls={};
Motion.Gesture.Record.Controls.Builder=function(b,c,d,e,a){this.controlPointGenerator=b;
this.controlPointLinker=c;
this.controlPointMerger=d;
this.controlSizer=e;
this.controlCleaner=a
};
Motion.Gesture.Record.Controls.Builder.prototype.build=function(d){var a=this.controlPointGenerator.parse(d);
var b=this.controlPointLinker.link(a);
var c=this.controlPointMerger.merge(b);
this.controlSizer.size(c);
this.controlCleaner.clean(c);
return{roots:c,metadata:d.metadata}
};
Motion.Gesture.Record.Controls.Cleaner=function(){};
Motion.Gesture.Record.Controls.Cleaner.prototype.clean=function(c){for(var b=0;
b<c.length;
b++){var d=c[b];
while(d){this.cleanControl(d);
for(var a=0;
a<d.points.length;
a++){this.cleanControlPoint(d.points[a])
}d=d.next
}}};
Motion.Gesture.Record.Controls.Cleaner.prototype.cleanControl=function(a){this.removeTimestamp(a)
};
Motion.Gesture.Record.Controls.Cleaner.prototype.cleanControlPoint=function(a){this.removeControlPointLinks(a)
};
Motion.Gesture.Record.Controls.Cleaner.prototype.removeTimestamp=function(a){a.timestamp=undefined
};
Motion.Gesture.Record.Controls.Cleaner.prototype.removeControlPointLinks=function(a){a.previous=undefined;
a.next=undefined
};
Motion.Gesture.Record.Controls.Linker=function(){};
Motion.Gesture.Record.Controls.Linker.prototype.link=function(b){var c=this.combineAxes(b.x,b.y,b.z);
var d=this.combineAxes(b.xg,b.yg,b.zg);
this.linkPoints(c);
this.linkPoints(d);
var a=[];
if(c.length>0){a[a.length]=c[0]
}if(d.length>0){a[a.length]=d[0]
}return a
};
Motion.Gesture.Record.Controls.Linker.prototype.linkPoints=function(c){var e=0;
var b=c.length-1;
for(var d=0;
d<c.length;
d++){var a=c[d];
a.previous=(d==e)?null:c[d-1];
a.next=(d==b)?null:c[d+1]
}};
Motion.Gesture.Record.Controls.Linker.prototype.combineAxes=function(b,j,h){var d=[];
var c=0;
var e=0;
var f=0;
while(c<b.length||e<j.length||f<h.length){var a=(c<b.length)?b[c].timestamp:Infinity;
var i=(e<j.length)?j[e].timestamp:Infinity;
var g=(f<h.length)?h[f].timestamp:Infinity;
if((g<=a)&&(g<=i)){d[d.length]=h[f];
f++
}else{if((i<=a)&&(i<=g)){d[d.length]=j[e];
e++
}else{d[d.length]=b[c];
c++
}}}return d
};
Motion.Gesture.Record.Controls.Merger=function(a){this.mergeTolerance=(a)?a:Motion.Gesture.Record.Controls.Merger.DEFAULT_MERGE_TOLERANCE
};
Motion.Gesture.Record.Controls.Merger.prototype.merge=function(c){var b=[];
for(var a=0;
a<c.length;
a++){b[b.length]=this.mergeLinkedList(c[a])
}return b
};
Motion.Gesture.Record.Controls.Merger.prototype.mergeLinkedList=function(d){var b=this.createControl(d);
var a=d;
var c=b;
while(a.next){a=a.next;
if(this.pointShouldBeMerged(c,a)===true){c=this.mergeControlPoint(c,a)
}else{c=this.linkToNewControl(c,a)
}}return b
};
Motion.Gesture.Record.Controls.Merger.prototype.pointShouldBeMerged=function(c,a){if(this.controlAlreadyHasPointInAxis(c,a.axis)===true){return false
}var b=c.timestamp.max+this.mergeTolerance;
if(a.timestamp>b){return false
}return true
};
Motion.Gesture.Record.Controls.Merger.prototype.controlAlreadyHasPointInAxis=function(c,b){for(var a=0;
a<c.points.length;
a++){if(c.points[a].axis===b){return true
}}return false
};
Motion.Gesture.Record.Controls.Merger.prototype.mergeControlPoint=function(b,a){b.points[b.points.length]=a;
b.timestamp.max=a.timestamp;
return b
};
Motion.Gesture.Record.Controls.Merger.prototype.linkToNewControl=function(c,a){var b=this.createControl(a);
b.previous=c;
c.next=b;
return b
};
Motion.Gesture.Record.Controls.Merger.prototype.createControl=function(a){var b={};
b.points=[];
b.points[0]=a;
b.timestamp={};
b.timestamp.min=a.timestamp;
b.timestamp.max=a.timestamp;
return b
};
Motion.Gesture.Record.Controls.Merger.DEFAULT_MERGE_TOLERANCE=250;
Motion.Gesture.Record.Controls.Sizer=function(){this.maxAccelerationDeviation=2;
this.maxTimeDeviation=250
};
Motion.Gesture.Record.Controls.Sizer.prototype.setMaxAccelerationDeviation=function(a){this.maxAccelerationDeviation=a
};
Motion.Gesture.Record.Controls.Sizer.prototype.setMaxTimeDeviation=function(a){this.maxTimeDeviation=a
};
Motion.Gesture.Record.Controls.Sizer.prototype.size=function(b){for(var a=0;
a<b.length;
a++){this.sizeLinkedList(b[a])
}};
Motion.Gesture.Record.Controls.Sizer.prototype.sizeLinkedList=function(a){this.sizeControl(a);
var b=a.next;
while(b){this.sizeControl(b);
b=b.next
}};
Motion.Gesture.Record.Controls.Sizer.prototype.sizeControl=function(b){b.window={};
b.window.time=this.computeTimeWindow(b);
for(var a=0;
a<b.points.length;
a++){this.sizePoint(b.points[a])
}};
Motion.Gesture.Record.Controls.Sizer.prototype.sizePoint=function(a){a.window={};
a.window.value=this.computeAccelerationWindow(a)
};
Motion.Gesture.Record.Controls.Sizer.prototype.computeTimeWindow=function(g){var c=this.computeTimesToAdjacentControls(g);
var b=this.computeTimeDeviation(c);
var a=g.timestamp.min-b;
var e=g.timestamp.max+b;
var f={};
f.width=e-a;
if(g.previous){var d=Motion.Gesture.Model.Control.getStartTime(g.previous)+(g.previous.window.time.width/2);
f.delay=a-d
}else{f.start=a
}return f
};
Motion.Gesture.Record.Controls.Sizer.prototype.computeTimesToAdjacentControls=function(c){var a;
if(c.previous){a=c.timestamp.min-c.previous.timestamp.max
}else{a=null
}var b;
if(c.next){b=c.next.timestamp.min-c.timestamp.max
}else{b=null
}return{fromPrevious:a,toNext:b}
};
Motion.Gesture.Record.Controls.Sizer.prototype.computeTimeDeviation=function(b){var a=Infinity;
if(b.fromPrevious!=null){a=Math.min(a,b.fromPrevious)
}a=Math.min(a,this.maxTimeDeviation);
return a
};
Motion.Gesture.Record.Controls.Sizer.prototype.computeAccelerationWindow=function(a){return{min:a.value-this.maxAccelerationDeviation,max:a.value+this.maxAccelerationDeviation}
};
if(typeof Motion==="undefined"){Motion={}
}if(typeof Motion.Gesture==="undefined"){Motion.Gesture={}
}if(typeof Motion.Gesture.Record==="undefined"){Motion.Gesture.Record={}
}if(typeof Motion.Gesture.Record.Controls==="undefined"){Motion.Gesture.Record.Controls={}
}Motion.Gesture.Record.Controls.PointGeneration={};
Motion.Gesture.Record.Controls.PointGeneration.Scorer=function(){};
Motion.Gesture.Record.Controls.PointGeneration.Scorer.prototype.score=function(b,e,g){if(b===Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_INCREASING){var a=this.gradientChange(e,g);
var d=e.values[g];
return(a*50)-d
}else{if(b===Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_DECREASING){var a=this.gradientChange(e,g);
var d=e.values[g];
return(a*-50)+d
}else{if(b===Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_STEADY){var f=this.preGradient(e,g);
var c=this.postGradient(e,g);
return(Math.abs(f)*5)-(Math.abs(c)*-5)
}}}return 0
};
Motion.Gesture.Record.Controls.PointGeneration.Scorer.prototype.gradient=function(e,a,d){var c=e.values[d]-e.values[a];
var b=e.times[d]-e.times[a];
return c/b
};
Motion.Gesture.Record.Controls.PointGeneration.Scorer.prototype.preGradient=function(a,b){if(b==0){return 0
}else{return this.gradient(a,b-1,b)
}};
Motion.Gesture.Record.Controls.PointGeneration.Scorer.prototype.postGradient=function(a,b){if(b==a.values.length-1){return 0
}else{return this.gradient(a,b,b+1)
}};
Motion.Gesture.Record.Controls.PointGeneration.Scorer.prototype.gradientChange=function(a,b){return this.postGradient(a,b)-this.preGradient(a,b)
};
Motion.Gesture.Record.Controls.PointGeneration.Generator=function(){this.stableMotionThreshold=0.3;
this.placementScorer=new Motion.Gesture.Record.Controls.PointGeneration.Scorer()
};
Motion.Gesture.Record.Controls.PointGeneration.Generator.prototype.parse=function(b){var a={};
a.x=this.parseAxis(b.x,"x");
a.y=this.parseAxis(b.y,"y");
a.z=this.parseAxis(b.z,"z");
a.xg=this.parseAxis(b.xg,"xg");
a.yg=this.parseAxis(b.yg,"yg");
a.zg=this.parseAxis(b.zg,"zg");
return a
};
Motion.Gesture.Record.Controls.PointGeneration.Generator.prototype.parseMotionDirection=function(b,a){var c=a-b;
if(c>this.stableMotionThreshold){return Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_INCREASING
}else{if(c<-this.stableMotionThreshold){return Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_DECREASING
}else{return Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_STEADY
}}};
Motion.Gesture.Record.Controls.PointGeneration.Generator.prototype.isChangeInMotionAlreadyDetected=function(a){return a!=null
};
Motion.Gesture.Record.Controls.PointGeneration.Generator.prototype.isConsistentChange=function(b,a){return b.direction===a
};
Motion.Gesture.Record.Controls.PointGeneration.Generator.prototype.createTrait=function(a,c,d,b){return{axis:a,timestamp:c.times[d],value:c.values[d],direction:b}
};
Motion.Gesture.Record.Controls.PointGeneration.Generator.prototype.findBestPlacement=function(e,d,g,b){var c=null;
for(var f=d-g;
f<=d+g;
f++){if(f>=0&&f<e.values.length){var a={index:f,score:this.placementScorer.score(b,e,f)};
if(c==null||a.score>c.score){c=a
}}}return c.index
};
Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_UNDEFINED=0;
Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_INCREASING=1;
Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_STEADY=2;
Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_DECREASING=3;
Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingConsistentChange=function(){this.consistentChangeCount=3
};
Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingConsistentChange.prototype=new Motion.Gesture.Record.Controls.PointGeneration.Generator();
Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingConsistentChange.prototype.parseAxis=function(a,b){var h=[];
var j=Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_UNDEFINED;
var g=null;
for(var d=1;
d<a.values.length;
d++){var c=this.parseMotionDirection(a.values[d-1],a.values[d]);
var e=false;
if(this.isChangeInMotionAlreadyDetected(g)===true){if(this.isConsistentChange(g,c)===true){g.consistencyCount++;
e=true;
if(g.consistencyCount>=this.consistentChangeCount){var f=this.createTrait(b,a,g.index,g.direction);
if(f){h[h.length]=f
}j=g.direction;
g=null
}}else{g=null
}}if(e===false&&c!==j){g={direction:c,index:d-1,consistencyCount:1}
}}return h
};
Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingConsistentChangeWithScoring=function(){this.consistentChangeCount=2
};
Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingConsistentChangeWithScoring.prototype=new Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingConsistentChange();
Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingConsistentChangeWithScoring.prototype.createTrait=function(a,d,e,c){var b=this.findBestPlacement(d,e,this.consistentChangeCount,c);
if(b!=null){return Motion.Gesture.Record.Controls.PointGeneration.Generator.prototype.createTrait.apply(this,[a,d,b,c])
}else{return null
}};
Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingLongTermChange=function(){this.readingDistance=3;
this.stableMotionThreshold=1
};
Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingLongTermChange.prototype=new Motion.Gesture.Record.Controls.PointGeneration.Generator();
Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingLongTermChange.prototype.parseAxis=function(d,c){var f=[];
var h=Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_UNDEFINED;
var g=null;
for(var b=this.readingDistance;
b<d.values.length;
b++){var e=b-this.readingDistance;
var a=this.parseMotionDirection(d.values[e],d.values[b]);
if(a!==h){this.appendNewTrait(f,c,d,g);
h=a;
g={direction:a,index:e}
}}this.appendNewTrait(f,c,d,g);
return f
};
Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingLongTermChange.prototype.appendNewTrait=function(d,b,c,e){if(e){var a=this.createTrait(b,c,e.index,e.direction);
if(a){d[d.length]=a
}}};
Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingLongTermChange.prototype.createTrait=function(a,d,e,c){var b=this.findBestPlacement(d,e,this.readingDistance,c);
if(b!=null){return Motion.Gesture.Record.Controls.PointGeneration.Generator.prototype.createTrait.apply(this,[a,d,b,c])
}else{return null
}};
if(typeof Motion==="undefined"){Motion={}
}if(typeof Motion.Gesture==="undefined"){Motion.Gesture={}
}if(typeof Motion.Gesture.Record==="undefined"){Motion.Gesture.Record={}
}Motion.Gesture.Record.Graphs={};
Motion.Gesture.Record.Graphs.AxisGraph=function(e,d,a,f,b,c){this.paper=e;
this.title=d;
this.x=a;
this.y=f;
this.size=b;
this.timeSpan=c;
this.series=[];
this.data={};
this.metadata={};
this.graphics={};
this.graphics.lines=[];
this.graphics.backgroundStyle=Motion.Gesture.Record.Graphs.AxisGraph.BACKGROUND_STYLE
};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.init=function(){this.initBackground();
this.initTitle()
};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.destroy=function(){this.destroyBackground();
this.destroyTitle();
this.destroyLines()
};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.initLines=function(){for(var a=0;
a<this.series.length;
a++){this.initLine(this.series[a])
}};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.destroyLines=function(){for(var a=0;
a<this.graphics.lines.length;
a++){if(this.graphics.lines[a]){this.graphics.lines[a].remove();
this.graphics.lines[a]=null
}}};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.initLine=function(a){if(!this.graphics.lines[a.id]){this.graphics.lines[a.id]=this.createLineGraphic(this.data[a.id]);
if(this.graphics.lines[a.id]){this.graphics.lines[a.id].attr({stroke:a.style.lineColour,opacity:a.style.lineOpacity})
}}};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.refreshLine=function(a){if(this.graphics.lines[a.id]){this.graphics.lines[a.id].attr({stroke:a.style.lineColour,opacity:a.style.lineOpacity})
}};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.destroyLine=function(a){if(this.graphics.lines[a.id]){this.graphics.lines[a.id].remove();
this.graphics.lines[a.id]=null
}};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.initBackground=function(){if(!this.graphics.background){this.graphics.background=this.paper.rect(this.x,this.y,this.size.width,this.size.height);
this.graphics.background.attr(this.graphics.backgroundStyle)
}};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.destroyBackground=function(){if(this.graphics.background){this.graphics.background.remove();
this.graphics.background=null
}};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.initTitle=function(){if(!this.graphics.title){this.graphics.title=this.paper.text(this.x,this.y,this.title);
this.graphics.title.attr(Motion.Gesture.Record.Graphs.AxisGraph.TITLE_STYLE);
var a=this.graphics.title.getBBox();
var c=this.x+(a.width/2)+Motion.Gesture.Record.Graphs.AxisGraph.TITLE_HORIZ_MARGIN;
var b=this.y+(a.height/2);
this.graphics.title.attr({x:c,y:b})
}if(!this.graphics.titleBackground){var a=this.graphics.title.getBBox();
this.graphics.titleBackground=this.paper.rect(this.x,this.y,a.width+(2*Motion.Gesture.Record.Graphs.AxisGraph.TITLE_HORIZ_MARGIN),a.height);
this.graphics.titleBackground.attr(Motion.Gesture.Record.Graphs.AxisGraph.TITLE_BACKGROUND_STYLE)
}this.graphics.title.toFront()
};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.destroyTitle=function(){if(this.graphics.title){this.graphics.title.remove();
this.graphics.title=null
}if(this.graphics.titleBackground){this.graphics.titleBackground.remove();
this.graphics.titleBackground=null
}};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.setData=function(b,c,a){if(typeof(this.series[b])=="undefined"){this.series[b]=b
}this.destroyLine(b);
this.data[b.id]=c;
this.metadata[b.id]=a;
this.initLine(b)
};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.setTimeSpan=function(a){this.timeSpan=a;
this.destroyLines();
this.initLines()
};
Motion.Gesture.Record.Graphs.AxisGraph.prototype.getPoint=function(h,f,k){var g=this.data[h.id];
var l=this.metadata[h.id];
var j=l.record.endTime;
var a=this.timeSpan;
var m=this.size.width/a;
var i=this.x+this.size.width-((j-f)*m);
var d=Motion.Gesture.Record.Graphs.RaphaelAxisGraph.YAXIS_RANGE/2;
var e=Motion.Gesture.Record.Graphs.RaphaelAxisGraph.YAXIS_RANGE;
var b=this.size.height/e;
var c=this.y+((d-k)*b);
return{x:i,y:c}
};
Motion.Gesture.Record.Graphs.AxisGraph.BACKGROUND_STYLE={fill:"#E0E0E0",stroke:"#C0C0C0"};
Motion.Gesture.Record.Graphs.AxisGraph.TITLE_STYLE={"font-size":14,"font-family":"tahoma, helvetica","font-weight":"bold",opacity:0.7};
Motion.Gesture.Record.Graphs.AxisGraph.TITLE_BACKGROUND_STYLE={fill:"#FFFFFF",opacity:0.3};
Motion.Gesture.Record.Graphs.AxisGraph.TITLE_HORIZ_MARGIN=3;
Motion.Gesture.Record.Graphs.GRaphaelAxisGraph=function(f,e,a,g,b,d,c){Motion.Gesture.Record.Graphs.AxisGraph.apply(this,[f,e,a,g,b,d,c])
};
Motion.Gesture.Record.Graphs.GRaphaelAxisGraph.prototype=new Motion.Gesture.Record.Graphs.AxisGraph();
Motion.Gesture.Record.Graphs.GRaphaelAxisGraph.prototype.createLineGraphic=function(b){var a=this.paper.linechart(this.x,this.y,this.size.width,this.size.height,b.times,b.values,{nostroke:false,axis:"0 0 0 1",symbol:"circle",smooth:true}).hoverColumn(function(){this.tags=this.paper.set();
for(var c=0,d=this.y.length;
c<d;
c++){this.tags.push(this.paper.tag(this.x,this.y[c],this.values[c],160,10).insertBefore(this).attr([{fill:"#fff"},{fill:this.symbols[c].attr("fill")}]))
}},function(){this.tags&&this.tags.remove()
});
a.symbols.attr({r:3});
return a
};
Motion.Gesture.Record.Graphs.Multiplex=function(e,d){this.paper=e;
this.graphType=Motion.Gesture.Record.Graphs.RaphaelAxisGraph;
this.graphs={};
var c={width:Motion.Gesture.Record.Graphs.Multiplex.DEFAULT_WIDTH,height:Motion.Gesture.Record.Graphs.Multiplex.DEFAULT_HEIGHT};
var a={};
a.x=0;
a.y=Motion.Gesture.Record.Graphs.Multiplex.TITLE_MARGIN;
this.graphs.x=new this.graphType(this.paper,"X",a.x,a.y,c,d);
this.graphs.x.init();
a.x=0;
a.y=Motion.Gesture.Record.Graphs.Multiplex.TITLE_MARGIN+c.height+Motion.Gesture.Record.Graphs.Multiplex.GRAPH_VERTICAL_SPACING;
this.graphs.y=new this.graphType(this.paper,"Y",a.x,a.y,c,d);
this.graphs.y.init();
a.x=0;
a.y=Motion.Gesture.Record.Graphs.Multiplex.TITLE_MARGIN+(2*(c.height+Motion.Gesture.Record.Graphs.Multiplex.GRAPH_VERTICAL_SPACING));
this.graphs.z=new this.graphType(this.paper,"Z",a.x,a.y,c,d);
this.graphs.z.init();
a.x=Motion.Gesture.Record.Graphs.Multiplex.GRAPH_HORIZ_SPACING+c.width;
a.y=Motion.Gesture.Record.Graphs.Multiplex.TITLE_MARGIN;
this.graphs.xg=new this.graphType(this.paper,"X",a.x,a.y,c,d);
this.graphs.xg.init();
a.x=Motion.Gesture.Record.Graphs.Multiplex.GRAPH_HORIZ_SPACING+c.width;
a.y=Motion.Gesture.Record.Graphs.Multiplex.TITLE_MARGIN+c.height+Motion.Gesture.Record.Graphs.Multiplex.GRAPH_VERTICAL_SPACING;
this.graphs.yg=new this.graphType(this.paper,"Y",a.x,a.y,c,d);
this.graphs.yg.init();
a.x=Motion.Gesture.Record.Graphs.Multiplex.GRAPH_HORIZ_SPACING+c.width;
a.y=Motion.Gesture.Record.Graphs.Multiplex.TITLE_MARGIN+(2*(c.height+Motion.Gesture.Record.Graphs.Multiplex.GRAPH_VERTICAL_SPACING));
this.graphs.zg=new this.graphType(this.paper,"Z",a.x,a.y,c,d);
this.graphs.zg.init();
this.signatureAnnotater=new Motion.Gesture.Record.Graphs.SignatureAnnotater(this.paper,this.graphs);
var b={};
b.x=c.width/2;
b.y=Motion.Gesture.Record.Graphs.Multiplex.TITLE_MARGIN/2;
this.titleWithoutGravity=this.paper.text(b.x,b.y,Motion.Gesture.Record.Graphs.Multiplex.TITLE_WITHOUT_GRAVITY);
this.titleWithoutGravity.attr(Motion.Gesture.Record.Graphs.Multiplex.TITLE_STYLE);
b.x=c.width+Motion.Gesture.Record.Graphs.Multiplex.GRAPH_HORIZ_SPACING+(c.width/2);
b.y=Motion.Gesture.Record.Graphs.Multiplex.TITLE_MARGIN/2;
this.titleWithGravity=this.paper.text(b.x,b.y,Motion.Gesture.Record.Graphs.Multiplex.TITLE_WITH_GRAVITY);
this.titleWithGravity.attr(Motion.Gesture.Record.Graphs.Multiplex.TITLE_STYLE)
};
Motion.Gesture.Record.Graphs.Multiplex.prototype.refresh=function(a){this.graphs.x.refreshLine(a);
this.graphs.y.refreshLine(a);
this.graphs.z.refreshLine(a);
this.graphs.xg.refreshLine(a);
this.graphs.yg.refreshLine(a);
this.graphs.zg.refreshLine(a);
this.signatureAnnotater.toFront()
};
Motion.Gesture.Record.Graphs.Multiplex.prototype.setData=function(b,a){this.graphs.x.setData(b,a.x,a.metadata);
this.graphs.y.setData(b,a.y,a.metadata);
this.graphs.z.setData(b,a.z,a.metadata);
this.graphs.xg.setData(b,a.xg,a.metadata);
this.graphs.yg.setData(b,a.yg,a.metadata);
this.graphs.zg.setData(b,a.zg,a.metadata)
};
Motion.Gesture.Record.Graphs.Multiplex.prototype.setSignature=function(a){this.signatureAnnotater.setData(a)
};
Motion.Gesture.Record.Graphs.Multiplex.prototype.setTimeSpan=function(a){this.graphs.x.setTimeSpan(a);
this.graphs.y.setTimeSpan(a);
this.graphs.z.setTimeSpan(a);
this.graphs.xg.setTimeSpan(a);
this.graphs.yg.setTimeSpan(a);
this.graphs.zg.setTimeSpan(a);
this.signatureAnnotater.refresh()
};
Motion.Gesture.Record.Graphs.Multiplex.prototype.setGesture=function(a){this.signatureAnnotater.setGesture(a)
};
Motion.Gesture.Record.Graphs.Multiplex.DEFAULT_WIDTH=300;
Motion.Gesture.Record.Graphs.Multiplex.DEFAULT_HEIGHT=125;
Motion.Gesture.Record.Graphs.Multiplex.TITLE_MARGIN=20;
Motion.Gesture.Record.Graphs.Multiplex.TITLE_STYLE={"font-size":14,"font-weight":"bold","font-family":"tahoma, helvetica","text-anchor":"middle"};
Motion.Gesture.Record.Graphs.Multiplex.TITLE_WITH_GRAVITY="Acceleration With Gravity";
Motion.Gesture.Record.Graphs.Multiplex.TITLE_WITHOUT_GRAVITY="Acceleration Without Gravity";
Motion.Gesture.Record.Graphs.Multiplex.GRAPH_VERTICAL_SPACING=5;
Motion.Gesture.Record.Graphs.Multiplex.GRAPH_HORIZ_SPACING=20;
Motion.Gesture.Record.Graphs.RaphaelAxisGraph=function(f,e,a,g,b,d,c){Motion.Gesture.Record.Graphs.AxisGraph.apply(this,[f,e,a,g,b,d,c])
};
Motion.Gesture.Record.Graphs.RaphaelAxisGraph.prototype=new Motion.Gesture.Record.Graphs.AxisGraph();
Motion.Gesture.Record.Graphs.RaphaelAxisGraph.prototype.createLineGraphic=function(c){if(c.times.length==0){return null
}var a="";
var b=c.times.length-1;
a+="M"+this.createPointString(c,b);
while(b>=0){var e=this.createPointString(c,b);
if(e!==null){a+="L"+e
}b--
}var d=this.paper.path(a);
d.attr(Motion.Gesture.Record.Graphs.RaphaelAxisGraph.LINE_STYLE);
return d
};
Motion.Gesture.Record.Graphs.RaphaelAxisGraph.prototype.createPointString=function(c,b){var a=this.createPoint(c,b);
if(a!==null){if(a.x>this.x){return""+a.x+","+a.y
}else{return null
}}else{return null
}};
Motion.Gesture.Record.Graphs.RaphaelAxisGraph.prototype.createPoint=function(g,j){if(j>=g.times.length||j>=g.values.length){return null
}var h=g.times[g.times.length-1];
var a=this.timeSpan;
var f=g.times[j];
var l=this.size.width/a;
var i=this.x+this.size.width-((h-f)*l);
var d=Motion.Gesture.Record.Graphs.RaphaelAxisGraph.YAXIS_RANGE/2;
var e=Motion.Gesture.Record.Graphs.RaphaelAxisGraph.YAXIS_RANGE;
var k=g.values[j];
var b=this.size.height/e;
var c=this.y+((d-k)*b);
return{x:i,y:c}
};
Motion.Gesture.Record.Graphs.RaphaelAxisGraph.LINE_STYLE={};
Motion.Gesture.Record.Graphs.RaphaelAxisGraph.YAXIS_RANGE=40;
Motion.Gesture.Record.Graphs.SignatureAnnotater=function(b,a){this.paper=b;
this.graphs=a;
this.selectedGesture=null;
this.signatures={};
this.graphics=[]
};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.setGesture=function(a){this.selectedGesture=a;
this.refresh()
};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.setData=function(a){this.signatures[a.id]=a.signature;
if(a==this.selectedGesture){this.refresh()
}};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.toFront=function(){for(var a=0;
a<this.graphics.length;
a++){this.graphics[a].toFront()
}};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.refresh=function(){this.clear();
this.draw()
};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.destroy=function(){this.clear()
};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.clear=function(){for(var a=0;
a<this.graphics.length;
a++){this.graphics[a].remove();
this.graphics[a]=null
}this.graphics=[]
};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.draw=function(){var a=this.signatures[this.selectedGesture.id];
if(a){this.drawSignature(a)
}};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.drawSignature=function(a){for(var b=0;
b<a.roots.length;
b++){this.drawControls(a.roots[b])
}};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.drawControls=function(a){this.drawControl(a);
var b=a;
while(b.next){b=b.next;
this.drawControl(b)
}};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.drawControl=function(e){var b=false;
for(var c=0;
c<e.points.length;
c++){var d=this.drawControlPoint(e,e.points[c]);
if(c>0){this.drawControlPointCombinedLine(e,e.points[c],e.points[c-1])
}b=b||d
}if(b===false){var a=e.points[0];
var f=this.getPreviousControlPoint(e,a);
if(f){this.drawControlPointLinkLine(e,a,f)
}}};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.drawControlPoint=function(c,f){var m=this.graphs[f.axis];
if(!m){return
}var d=Motion.Gesture.Model.Control.getStartTime(c);
var a=m.getPoint(this.selectedGesture,f.timestamp,f.value);
var k=m.getPoint(this.selectedGesture,d,f.window.value.max);
var g=m.getPoint(this.selectedGesture,d+c.window.time.width,f.window.value.min);
var b=g.x-k.x;
var l=g.y-k.y;
var h=this.paper.rect(k.x,k.y,b,l);
this.graphics[this.graphics.length]=h;
h.attr(Motion.Gesture.Record.Graphs.SignatureAnnotater.WINDOW_STYLE);
var j=this.paper.circle(a.x,a.y,Motion.Gesture.Record.Graphs.SignatureAnnotater.SPOT_RADIUS);
this.graphics[this.graphics.length]=j;
j.attr(Motion.Gesture.Record.Graphs.SignatureAnnotater.SPOT_STYLE);
j.attr(Motion.Gesture.Record.Graphs.SignatureAnnotater.SPOT_TYPE_STYLE[f.direction]);
var e=false;
var i=this.getPreviousControlPointInSameAxis(c,f.axis);
if(i){this.drawControlPointLinkLine(c,f,i,k);
e=true
}return e
};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.drawControlPointCombinedLine=function(g,c,f){var h=Motion.Gesture.Model.Control.getStartTime(g);
var d=this.getPoint(c,h,c.value);
var e=this.getPoint(f,h,f.value);
var b="";
b+="M"+d.x+","+d.y;
b+="L"+e.x+","+e.y;
var a=this.paper.path(b);
this.graphics[this.graphics.length]=a;
a.attr(Motion.Gesture.Record.Graphs.SignatureAnnotater.COMBINE_LINE_STYLE)
};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.drawControlPointLinkLine=function(f,c,h,d){var b=(d)?d:this.getPoint(c,Motion.Gesture.Model.Control.getStartTime(f),c.window.value.max);
var a=this.getPoint(h,h.timestamp,h.value);
var g="";
g+="M"+a.x+","+a.y;
g+="L"+a.x+","+b.y;
g+="L"+b.x+","+b.y;
var e=this.paper.path(g);
this.graphics[this.graphics.length]=e;
e.attr(Motion.Gesture.Record.Graphs.SignatureAnnotater.LINK_STYLE)
};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.getPreviousControlPoint=function(e,b){var d=null;
if(e.previous){var a=Motion.Gesture.Record.Graphs.SignatureAnnotater.PREFERRED_AXIS_LINK[b.axis];
for(var c=0;
c<e.previous.points.length;
c++){if(d&&d.axis===a){}else{d=e.previous.points[c]
}}}return d
};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.getPreviousControlPointInSameAxis=function(c,b){if(c.previous){for(var a=0;
a<c.previous.points.length;
a++){if(c.previous.points[a].axis==b){return c.previous.points[a]
}}}return null
};
Motion.Gesture.Record.Graphs.SignatureAnnotater.prototype.getPoint=function(a,d,c){var b=this.graphs[a.axis];
if(!b){console.log("MG: No graph found for axis '"+a.axis+"'.");
return null
}return b.getPoint(this.selectedGesture,d,c)
};
Motion.Gesture.Record.Graphs.SignatureAnnotater.WINDOW_STYLE={stroke:"#808080",opacity:0.7};
Motion.Gesture.Record.Graphs.SignatureAnnotater.COMBINE_LINE_STYLE={stroke:"#808080","stroke-dasharray":"- ",opacity:0.3};
Motion.Gesture.Record.Graphs.SignatureAnnotater.LINK_STYLE={stroke:"#404040","stroke-width":2,opacity:0.9};
Motion.Gesture.Record.Graphs.SignatureAnnotater.SPOT_RADIUS=4;
Motion.Gesture.Record.Graphs.SignatureAnnotater.SPOT_STYLE={stroke:"#808080",opacity:0.7};
Motion.Gesture.Record.Graphs.SignatureAnnotater.SPOT_TYPE_STYLE=[];
Motion.Gesture.Record.Graphs.SignatureAnnotater.SPOT_TYPE_STYLE[Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_UNDEFINED]={stroke:"#808080"};
Motion.Gesture.Record.Graphs.SignatureAnnotater.SPOT_TYPE_STYLE[Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_INCREASING]={stroke:"#606090"};
Motion.Gesture.Record.Graphs.SignatureAnnotater.SPOT_TYPE_STYLE[Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_STEADY]={stroke:"#906060"};
Motion.Gesture.Record.Graphs.SignatureAnnotater.SPOT_TYPE_STYLE[Motion.Gesture.Record.Controls.PointGeneration.Generator.MOTION_DECREASING]={stroke:"#609060"};
Motion.Gesture.Record.Graphs.SignatureAnnotater.PREFERRED_AXIS_LINK={};
Motion.Gesture.Record.Graphs.SignatureAnnotater.PREFERRED_AXIS_LINK.x="y";
Motion.Gesture.Record.Graphs.SignatureAnnotater.PREFERRED_AXIS_LINK.y="x";
Motion.Gesture.Record.Graphs.SignatureAnnotater.PREFERRED_AXIS_LINK.z="y";
Motion.Gesture.Record.Graphs.SignatureAnnotater.PREFERRED_AXIS_LINK.xg="yg";
Motion.Gesture.Record.Graphs.SignatureAnnotater.PREFERRED_AXIS_LINK.yg="xg";
Motion.Gesture.Record.Graphs.SignatureAnnotater.PREFERRED_AXIS_LINK.zg="yg";
Motion.Gesture.Record.Interface=function(a,c,b){this.recorder=a;
this.gestures=c;
this.elementIds=b;
this.selectedGesture=null
};
Motion.Gesture.Record.Interface.prototype.init=function(a){this.associateTrigger(this.elementIds.motion.start,Motion.Gesture.Record.Interface.prototype.handleStartRecording);
this.associateTrigger(this.elementIds.motion.stop,Motion.Gesture.Record.Interface.prototype.handleStopRecording);
this.associateTrigger(this.elementIds.motion.clear,Motion.Gesture.Record.Interface.prototype.handleClearMotionData);
this.associateTrigger(this.elementIds.motion.output,Motion.Gesture.Record.Interface.prototype.handleOutputMotionData);
this.associateTrigger(this.elementIds.motion.input,Motion.Gesture.Record.Interface.prototype.handleInputMotionData);
this.associateTrigger(this.elementIds.gesture.test,Motion.Gesture.Record.Interface.prototype.handleTestGesture);
this.associateTrigger(this.elementIds.gesture.output,Motion.Gesture.Record.Interface.prototype.handleOutputGesture);
this.associateTrigger(this.elementIds.gesture.input,Motion.Gesture.Record.Interface.prototype.handleInputGesture);
this.associateTrigger(this.elementIds.gesture.copy,Motion.Gesture.Record.Interface.prototype.handleCopyMotion);
this.associateTrigger(this.elementIds.gesture.clear,Motion.Gesture.Record.Interface.prototype.handleClearGesture);
this.associateTrigger(this.elementIds.gesture.opacity.increase,Motion.Gesture.Record.Interface.prototype.handleIncreaseOpacity);
this.associateTrigger(this.elementIds.gesture.opacity.decrease,Motion.Gesture.Record.Interface.prototype.handleDecreaseOpacity);
for(var d=0;
d<this.gestures.length;
d++){var c=this.gestures[d];
var b=this.associateTrigger(c.ui.tabElementId,Motion.Gesture.Record.Interface.prototype.handleSelectGesture,c);
b.style.backgroundColor=c.ui.tabColour;
this.recorder.setGestureData(c)
}this.selectGesture(a);
var e=this;
this.recorder.addGestureRecognitionHandler(function(f){e.flashGestureRecognised(f)
})
};
Motion.Gesture.Record.Interface.prototype.associateTrigger=function(a,e,d){var b;
if(a){b=document.getElementById(a);
if(b){var c=this;
b.onclick=function(){e.apply(c,[d])
}
}}return b
};
Motion.Gesture.Record.Interface.prototype.handleStartRecording=function(){this.recorder.startRecording()
};
Motion.Gesture.Record.Interface.prototype.handleStopRecording=function(){this.recorder.stopRecording()
};
Motion.Gesture.Record.Interface.prototype.handleClearMotionData=function(){this.recorder.clearMotionData()
};
Motion.Gesture.Record.Interface.prototype.handleOutputMotionData=function(){var a=this.recorder.getMotionDataAsJson();
if(this.elementIds.output&&document.getElementById(this.elementIds.output)){document.getElementById(this.elementIds.output).innerHTML="<h2>LIVE MOTION DATA</h2>"+a
}else{alert(a)
}};
Motion.Gesture.Record.Interface.prototype.handleInputMotionData=function(){var a=prompt("Enter the data as JSON:");
if(a!=null){this.recorder.parseMotionDataFromJson(a)
}};
Motion.Gesture.Record.Interface.prototype.handleSelectGesture=function(a){this.selectGesture(a)
};
Motion.Gesture.Record.Interface.prototype.selectGesture=function(d){var c=d.ui.tabElementId;
var a=this.elementIds.gesture.panel;
if(c&&a){var b=document.getElementById(c);
var e=document.getElementById(a);
if(b&&e){this.selectedGesture=d;
e.style.backgroundColor=d.ui.tabColour;
this.refreshOpacityValue()
}}this.recorder.selectGesture(d)
};
Motion.Gesture.Record.Interface.prototype.handleTestGesture=function(){if(Motion.Gesture.Model.Gesture.isDefined(this.selectedGesture)){this.recorder.testGestureWithMotionData(this.selectedGesture)
}};
Motion.Gesture.Record.Interface.prototype.handleOutputGesture=function(){var a=this.recorder.getGestureDefinitionAsJson(this.selectedGesture,Motion.Gesture.Record.Interface.GESTURE_JSON_INDENTATION);
if(this.elementIds.output&&document.getElementById(this.elementIds.output)){document.getElementById(this.elementIds.output).innerHTML="<h2>GESTURE "+this.selectedGesture.id.toUpperCase()+"</h2><pre>"+a+"</pre>"
}else{alert(a)
}};
Motion.Gesture.Record.Interface.prototype.handleInputGesture=function(){var a=prompt("Enter the gesture definition as JSON:");
if(a!=null){this.recorder.parseGestureDefinitionFromJson(this.selectedGesture,a)
}};
Motion.Gesture.Record.Interface.prototype.handleCopyMotion=function(){this.recorder.copyMotionToGesture(this.selectedGesture)
};
Motion.Gesture.Record.Interface.prototype.handleClearGesture=function(){this.recorder.clearGesture(this.selectedGesture)
};
Motion.Gesture.Record.Interface.prototype.handleIncreaseOpacity=function(){this.selectedGesture.style.lineOpacity+=0.2;
if(this.selectedGesture.style.lineOpacity>1){this.selectedGesture.style.lineOpacity=1
}this.recorder.refreshGestureGraph(this.selectedGesture);
this.refreshOpacityValue()
};
Motion.Gesture.Record.Interface.prototype.handleDecreaseOpacity=function(){this.selectedGesture.style.lineOpacity-=0.2;
if(this.selectedGesture.style.lineOpacity<0){this.selectedGesture.style.lineOpacity=0
}this.recorder.refreshGestureGraph(this.selectedGesture);
this.refreshOpacityValue()
};
Motion.Gesture.Record.Interface.prototype.refreshOpacityValue=function(){var a=document.getElementById(this.elementIds.gesture.opacity.value);
if(a){a.innerHTML=""+Math.round(this.selectedGesture.style.lineOpacity*100)+"%"
}};
Motion.Gesture.Record.Interface.prototype.flashGestureRecognised=function(b){var a=document.getElementById(b.ui.tabElementId);
if(a){a.style.backgroundColor="#000000";
var c=function(){a.style.backgroundColor=b.ui.tabColour
};
window.setTimeout(c,750)
}};
Motion.Gesture.Record.Interface.GESTURE_JSON_INDENTATION="   ";
Motion.Gesture.Record.MotionDataManager=function(b,a,c){this.data=b;
this.timeSpan=a;
this.autoTruncate=c
};
Motion.Gesture.Record.MotionDataManager.prototype.setTimeSpan=function(a){this.timeSpan=a
};
Motion.Gesture.Record.MotionDataManager.prototype.setAutoTruncate=function(a){this.autoTruncate=a
};
Motion.Gesture.Record.MotionDataManager.prototype.setData=function(a){this.data.metadata=(a.metadata)?a.metadata:Motion.Gesture.Record.MotionDataManager.newMetadata();
this.data.x=a.x;
this.data.y=a.y;
this.data.z=a.z;
this.data.xg=a.xg;
this.data.yg=a.yg;
this.data.zg=a.zg
};
Motion.Gesture.Record.MotionDataManager.prototype.createCopy=function(){return Motion.Gesture.Record.MotionDataManager.createCopy(this.data)
};
Motion.Gesture.Record.MotionDataManager.prototype.clear=function(){this.data.metadata=Motion.Gesture.Record.MotionDataManager.newMetadata();
this.clearAxis("x");
this.clearAxis("y");
this.clearAxis("z");
this.clearAxis("xg");
this.clearAxis("yg");
this.clearAxis("zg")
};
Motion.Gesture.Record.MotionDataManager.prototype.clearAxis=function(b){var a=this.data[b];
a.values=[];
a.times=[]
};
Motion.Gesture.Record.MotionDataManager.prototype.append=function(b,a){if(!this.data.metadata.record.endTime||b>this.data.metadata.record.endTime){this.data.metadata.record.endTime=b
}this.appendToAxis("x",b,a.x);
this.appendToAxis("y",b,a.y);
this.appendToAxis("z",b,a.z);
this.appendToAxis("xg",b,a.xg);
this.appendToAxis("yg",b,a.yg);
this.appendToAxis("zg",b,a.zg)
};
Motion.Gesture.Record.MotionDataManager.prototype.appendToAxis=function(b,d,c){var a=this.data[b];
a.times[a.times.length]=d;
a.values[a.values.length]=c;
if(this.autoTruncate===true){this.truncate()
}};
Motion.Gesture.Record.MotionDataManager.prototype.truncate=function(){this.truncateAxis("x");
this.truncateAxis("y");
this.truncateAxis("z");
this.truncateAxis("xg");
this.truncateAxis("yg");
this.truncateAxis("zg")
};
Motion.Gesture.Record.MotionDataManager.prototype.truncateAxis=function(e){var c=this.data[e];
if(this.timeSpan&&c.times.length>1){var b=c.times[c.times.length-1];
var d=b-this.timeSpan;
var a=0;
while(c.times[a]<d){a++
}if(a>0){c.times.splice(0,a);
c.values.splice(0,a)
}}};
Motion.Gesture.Record.MotionDataManager.prototype.dataAsJson=function(){if(!JSON){alert("Your browser does not support JSON processing. Please upgrade to a more recent browser.");
return null
}else{return JSON.stringify(this.data)
}};
Motion.Gesture.Record.MotionDataManager.prototype.dataFromJson=function(a){if(!JSON){alert("Your browser does not support JSON processing. Please upgrade to a more recent browser.");
return null
}else{this.setData(JSON.parse(a))
}};
Motion.Gesture.Record.MotionDataManager.prototype.iterate=function(a,d){var c=(d)?d:0;
var g=this.data.x.times.length;
for(var b=0;
b<g;
b++){var f=this.data.x.times[b];
if(f>c){var e={timestamp:f,x:this.data.x.values[b],y:this.data.y.values[b],z:this.data.z.values[b],xg:this.data.xg.values[b],yg:this.data.yg.values[b],zg:this.data.zg.values[b]};
a(e)
}}};
Motion.Gesture.Record.MotionDataManager.newData=function(a){var b=(a)?a:Motion.Gesture.Record.MotionDataManager.newMetadata();
return{metadata:b,x:Motion.Gesture.Record.MotionDataManager.newAxisData(),y:Motion.Gesture.Record.MotionDataManager.newAxisData(),z:Motion.Gesture.Record.MotionDataManager.newAxisData(),xg:Motion.Gesture.Record.MotionDataManager.newAxisData(),yg:Motion.Gesture.Record.MotionDataManager.newAxisData(),zg:Motion.Gesture.Record.MotionDataManager.newAxisData()}
};
Motion.Gesture.Record.MotionDataManager.newMetadata=function(){return{record:{endTime:null}}
};
Motion.Gesture.Record.MotionDataManager.newAxisData=function(){return{values:[],times:[]}
};
Motion.Gesture.Record.MotionDataManager.createCopy=function(a){return{metadata:a.metadata,x:Motion.Gesture.Record.MotionDataManager.createAxisCopy(a.x),y:Motion.Gesture.Record.MotionDataManager.createAxisCopy(a.y),z:Motion.Gesture.Record.MotionDataManager.createAxisCopy(a.z),xg:Motion.Gesture.Record.MotionDataManager.createAxisCopy(a.xg),yg:Motion.Gesture.Record.MotionDataManager.createAxisCopy(a.yg),zg:Motion.Gesture.Record.MotionDataManager.createAxisCopy(a.zg)}
};
Motion.Gesture.Record.MotionDataManager.createAxisCopy=function(a){return{values:Motion.Gesture.Record.MotionDataManager.createArrayCopy(a.values),times:Motion.Gesture.Record.MotionDataManager.createArrayCopy(a.times)}
};
Motion.Gesture.Record.MotionDataManager.createArrayCopy=function(c){var b=[];
for(var a=0;
a<c.length;
a++){b[a]=c[a]
}return b
};
Motion.Gesture.Record.Recorder=function(d,c){var a=(c)?c:{};
var b=(a.timeSpan)?a.timeSpan:Motion.Gesture.Record.Recorder.DEFAULT_TIME_SPAN;
var e=(a.autoTruncate)?a.autoTruncate:Motion.Gesture.Record.Recorder.DEFAULT_TIME_SPAN;
this.recordingPeriod=(a.recordingPeriod)?a.recordingPeriod:Motion.Gesture.Record.Recorder.DEFAULT_RECORDING_PERIOD;
this.refreshPeriod=(a.refreshPeriod)?a.refreshPeriod:Motion.Gesture.Record.Recorder.DEFAULT_REFRESH_PERIOD;
this.recognitionPeriod=(a.recognitionPeriod)?a.recognitionPeriod:Motion.Gesture.Record.Recorder.DEFAULT_RECOGNITION_PERIOD;
this.motionData=Motion.Gesture.Record.MotionDataManager.newData();
this.motionDataChanged=false;
this.motionDataManager=new Motion.Gesture.Record.MotionDataManager(this.motionData,b,e);
this.graphs=new Motion.Gesture.Record.Graphs.Multiplex(d,b);
this.gestureBuilder=new Motion.Gesture.Record.Controls.Builder(new Motion.Gesture.Record.Controls.PointGeneration.GeneratorUsingConsistentChangeWithScoring(),new Motion.Gesture.Record.Controls.Linker(),new Motion.Gesture.Record.Controls.Merger(),new Motion.Gesture.Record.Controls.Sizer(),new Motion.Gesture.Record.Controls.Cleaner());
this.gestureRecogniser=new Motion.Gesture.Recognition.Monitor();
this.lastRecognitionTimestamp=0;
this.gestureRecognitionHandlers=[];
this.startRecording();
this.startRefreshing()
};
Motion.Gesture.Record.Recorder.prototype.destroy=function(){this.stopRecording();
this.stopRefreshing()
};
Motion.Gesture.Record.Recorder.prototype.startRefreshing=function(){if(this.refreshInterval){return
}var b=this;
var a=function(){b.refreshLiveDataGraph()
};
this.refreshInterval=window.setInterval(a,this.refreshPeriod)
};
Motion.Gesture.Record.Recorder.prototype.refreshLiveDataGraph=function(){if(this.motionDataChanged===true){this.graphs.setData(Motion.Gesture.Record.Recorder.MOTION_DATA_SERIES,this.motionData);
this.motionDataChanged=false
}};
Motion.Gesture.Record.Recorder.prototype.stopRefreshing=function(){if(this.refreshInterval){window.clearInterval(this.refreshInterval);
this.refreshInterval=null
}};
Motion.Gesture.Record.Recorder.prototype.startRecording=function(){if(this.recordingInterval){this.stopRecording()
}var b=this;
var a=function(){b.recordMotionData()
};
this.recordingInterval=window.setInterval(a,this.recordingPeriod);
this.startRecognising()
};
Motion.Gesture.Record.Recorder.prototype.stopRecording=function(){if(this.recordingInterval){window.clearInterval(this.recordingInterval);
this.recordingInterval=null
}this.stopRecognising()
};
Motion.Gesture.Record.Recorder.prototype.startRecognising=function(){if(this.recognitionInterval){return
}var b=this;
var a=function(){b.recogniseFromLiveData()
};
this.recognitionInterval=window.setInterval(a,this.recognitionPeriod)
};
Motion.Gesture.Record.Recorder.prototype.recogniseFromLiveData=function(){var a=this;
this.motionDataManager.iterate(function(b){a.gestureRecogniser.process(b);
a.lastRecognitionTimestamp=b.timestamp
},a.lastRecognitionTimestamp)
};
Motion.Gesture.Record.Recorder.prototype.stopRecognising=function(){this.gestureRecogniser.stopAllThreads();
if(this.recognitionInterval){window.clearInterval(this.recognitionInterval);
this.recognitionInterval=null
}};
Motion.Gesture.Record.Recorder.prototype.setTimeSpan=function(a){this.motionDataManager.setTimeSpan(a);
this.graphs.setTimeSpan(a)
};
Motion.Gesture.Record.Recorder.prototype.setGraphSize=function(a){this.graphs.setGraphSize(a)
};
Motion.Gesture.Record.Recorder.prototype.addGestureRecognitionHandler=function(a){this.gestureRecognitionHandlers[this.gestureRecognitionHandlers.length]=a
};
Motion.Gesture.Record.Recorder.prototype.getMotionDataAsJson=function(){return this.motionDataManager.dataAsJson()
};
Motion.Gesture.Record.Recorder.prototype.parseMotionDataFromJson=function(a){this.motionDataManager.dataFromJson(a);
this.graphs.setData(Motion.Gesture.Record.Recorder.MOTION_DATA_SERIES,this.motionData)
};
Motion.Gesture.Record.Recorder.prototype.clearMotionData=function(){this.motionDataManager.clear();
this.graphs.setData(Motion.Gesture.Record.Recorder.MOTION_DATA_SERIES,this.motionData)
};
Motion.Gesture.Record.Recorder.prototype.recordMotionData=function(){if(this.deviceMotionData){this.motionDataManager.append(new Date().getTime(),this.deviceMotionData);
this.motionDataChanged=true
}else{var a={x:10-(Math.random()*20),y:10-(Math.random()*20),z:10-(Math.random()*20),xg:10-(Math.random()*20),yg:10-(Math.random()*20),zg:10-(Math.random()*20)};
this.motionDataManager.append(new Date().getTime(),a);
this.motionDataChanged=true
}};
Motion.Gesture.Record.Recorder.prototype.handleDeviceMotion=function(a){this.deviceMotionData={x:a.acceleration.x,y:a.acceleration.y,z:a.acceleration.z,xg:a.accelerationIncludingGravity.x,yg:a.accelerationIncludingGravity.y,zg:a.accelerationIncludingGravity.z}
};
Motion.Gesture.Record.Recorder.prototype.selectGesture=function(a){this.graphs.setGesture(a)
};
Motion.Gesture.Record.Recorder.prototype.testGestureWithMotionData=function(a){var b=new Motion.Gesture.Recognition.Monitor();
b.addGesture(a,function(){alert("Motion data matched gesture "+a.id+".")
});
this.motionDataManager.iterate(function(c){b.process(c)
})
};
Motion.Gesture.Record.Recorder.prototype.getGestureDefinitionAsJson=function(b,a){if(!JSON){alert("Your browser does not support JSON processing. Please upgrade to a more recent browser.");
return null
}else{return Motion.Gesture.Model.Serialisation.signatureToJson(b.signature,a)
}};
Motion.Gesture.Record.Recorder.prototype.parseGestureDefinitionFromJson=function(b,a){if(!JSON){alert("Your browser does not support JSON processing. Please upgrade to a more recent browser.");
return null
}else{b.signature=Motion.Gesture.Model.Serialisation.signatureFromJson(a);
this.setGestureData(b)
}};
Motion.Gesture.Record.Recorder.prototype.copyMotionToGesture=function(a){var b=this.motionDataManager.createCopy();
a.signature=this.gestureBuilder.build(b);
this.setGestureData(a,b)
};
Motion.Gesture.Record.Recorder.prototype.setGestureData=function(b,c){if(!b.signature){return
}var a=(c)?c:Motion.Gesture.Record.MotionDataManager.newData(b.signature.metadata);
this.graphs.setData(b,a);
this.graphs.setSignature(b);
var d=this;
this.gestureRecogniser.addGesture(b,function(){for(var e=0;
e<d.gestureRecognitionHandlers.length;
e++){d.gestureRecognitionHandlers[e](b)
}})
};
Motion.Gesture.Record.Recorder.prototype.clearGesture=function(a){a.signature=null;
this.graphs.setData(a,new Motion.Gesture.Record.MotionDataManager.newData());
this.graphs.setSignature(a);
this.gestureRecogniser.removeGesture(a)
};
Motion.Gesture.Record.Recorder.prototype.refreshGestureGraph=function(a){this.graphs.refresh(a)
};
Motion.Gesture.Record.Recorder.DEFAULT_RECORDING_PERIOD=25;
Motion.Gesture.Record.Recorder.DEFAULT_TIME_SPAN=5000;
Motion.Gesture.Record.Recorder.DEFAULT_AUTO_TRUNCATE=true;
Motion.Gesture.Record.Recorder.DEFAULT_REFRESH_PERIOD=100;
Motion.Gesture.Record.Recorder.DEFAULT_RECOGNITION_PERIOD=100;
Motion.Gesture.Record.Recorder.MOTION_DATA_SERIES={id:"motion",style:{lineColour:"#000000",lineOpacity:1}};